Add another verbosity level to git-fetch
[git/git.git] / git-fetch.sh
CommitLineData
7ef76925
LT
1#!/bin/sh
2#
87358b7a
FK
3
4USAGE='<fetch-options> <repository> <refspec>...'
4da90285 5SUBDIRECTORY_OK=Yes
ae2b0f15 6. git-sh-setup
f9474132 7set_reflog_action "fetch $*"
514c09fd 8cd_to_toplevel ;# probably unnecessary...
f9474132 9
215a7ad1 10. git-parse-remote
853a3697
JH
11_x40='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
12_x40="$_x40$_x40$_x40$_x40$_x40$_x40$_x40$_x40"
13
221e743c
JH
14LF='
15'
16IFS="$LF"
17
03febf99 18no_tags=
ed1aadf1 19tags=
853a3697 20append=
ae2da406 21force=
583122cd 22verbose=
b10ac50f 23update_head_ok=
2c620a1a 24exec=
920ccbfc 25keep=
f53514bc 26shallow_depth=
83a5ad61
JS
27no_progress=
28test -t 1 || no_progress=--no-progress
a858c006 29quiet=
ae2da406
JH
30while case "$#" in 0) break ;; esac
31do
32 case "$1" in
33 -a|--a|--ap|--app|--appe|--appen|--append)
34 append=t
ae2da406 35 ;;
2796a9de
JH
36 --upl|--uplo|--uploa|--upload|--upload-|--upload-p|\
37 --upload-pa|--upload-pac|--upload-pack)
2c620a1a 38 shift
ae1dffcb
JH
39 exec="--upload-pack=$1"
40 ;;
41 --upl=*|--uplo=*|--uploa=*|--upload=*|\
42 --upload-=*|--upload-p=*|--upload-pa=*|--upload-pac=*|--upload-pack=*)
4a91a1f3 43 exec=--upload-pack=$(expr "z$1" : 'z-[^=]*=\(.*\)')
ae1dffcb 44 shift
2c620a1a 45 ;;
ae2da406
JH
46 -f|--f|--fo|--for|--forc|--force)
47 force=t
b10ac50f 48 ;;
ed1aadf1
LT
49 -t|--t|--ta|--tag|--tags)
50 tags=t
51 ;;
03febf99
JH
52 -n|--n|--no|--no-|--no-t|--no-ta|--no-tag|--no-tags)
53 no_tags=t
54 ;;
b10ac50f
JH
55 -u|--u|--up|--upd|--upda|--updat|--update|--update-|--update-h|\
56 --update-he|--update-hea|--update-head|--update-head-|\
57 --update-head-o|--update-head-ok)
58 update_head_ok=t
ae2da406 59 ;;
a858c006
JH
60 -q|--q|--qu|--qui|--quie|--quiet)
61 quiet=--quiet
62 ;;
583122cd 63 -v|--verbose)
684f6742 64 verbose="$verbose"Yes
583122cd 65 ;;
0f76f526 66 -k|--k|--ke|--kee|--keep)
576162a4 67 keep='-k -k'
0f76f526 68 ;;
f53514bc
JS
69 --depth=*)
70 shallow_depth="--depth=`expr "z$1" : 'z-[^=]*=\(.*\)'`"
71 ;;
72 --depth)
73 shift
74 shallow_depth="--depth=$1"
75 ;;
87358b7a
FK
76 -*)
77 usage
78 ;;
ae2da406
JH
79 *)
80 break
81 ;;
82 esac
b10ac50f 83 shift
ae2da406
JH
84done
85
853a3697
JH
86case "$#" in
870)
648ad18f
SB
88 origin=$(get_default_remote)
89 test -n "$(get_remote_url ${origin})" ||
90 die "Where do you want to fetch from today?"
91 set x $origin ; shift ;;
853a3697 92esac
ae2da406 93
5dee29ac
UKK
94if test -z "$exec"
95then
96 # No command line override and we have configuration for the remote.
97 exec="--upload-pack=$(get_uploadpack $1)"
98fi
99
853a3697
JH
100remote_nick="$1"
101remote=$(get_remote_url "$@")
102refs=
103rref=
104rsync_slurped_objects=
105
106if test "" = "$append"
107then
df34297a 108 : >"$GIT_DIR/FETCH_HEAD"
853a3697
JH
109fi
110
28b8e61f 111# Global that is reused later
ae1dffcb 112ls_remote_result=$(git ls-remote $exec "$remote") ||
b3d98993 113 die "Cannot get the repository state from $remote"
28b8e61f 114
853a3697 115append_fetch_head () {
d4289fff 116 flags=
08727ea8
SB
117 test -n "$verbose" && flags="$flags$LF-v"
118 test -n "$force$single_force" && flags="$flags$LF-f"
d4289fff 119 GIT_REFLOG_ACTION="$GIT_REFLOG_ACTION" \
fee7c2c7 120 git-fetch--tool $flags append-fetch-head "$@"
853a3697
JH
121}
122
4b441f47
JH
123# updating the current HEAD with git-fetch in a bare
124# repository is always fine.
125if test -z "$update_head_ok" && test $(is_bare_repository) = false
126then
bf7960eb 127 orig_head=$(git-rev-parse --verify HEAD 2>/dev/null)
4b441f47 128fi
b10ac50f 129
24424fc2
JH
130# Allow --notags from remote.$1.tagopt
131case "$tags$no_tags" in
132'')
133 case "$(git-config --get "remote.$1.tagopt")" in
134 --no-tags)
135 no_tags=t ;;
136 esac
137esac
138
ed1aadf1
LT
139# If --tags (and later --heads or --all) is specified, then we are
140# not talking about defaults stored in Pull: line of remotes or
141# branches file, and just fetch those and refspecs explicitly given.
142# Otherwise we do what we always did.
143
144reflist=$(get_remote_refs_for_fetch "$@")
145if test "$tags"
146then
ed9f7c95 147 taglist=`IFS=' ' &&
28b8e61f 148 echo "$ls_remote_result" |
85b1f988 149 git-show-ref --exclude-existing=refs/tags/ |
81214e4d
JH
150 while read sha1 name
151 do
85b1f988 152 echo ".${name}:${name}"
57a39690 153 done` || exit
ed1aadf1
LT
154 if test "$#" -gt 1
155 then
156 # remote URL plus explicit refspecs; we need to merge them.
221e743c 157 reflist="$reflist$LF$taglist"
ed1aadf1
LT
158 else
159 # No explicit refspecs; fetch tags only.
160 reflist=$taglist
161 fi
162fi
163
9debc324 164fetch_all_at_once () {
d1e0ef6c 165
617669da 166 eval=$(echo "$1" | git-fetch--tool parse-reflist "-")
d1e0ef6c 167 eval "$eval"
b74e8cbd
JH
168
169 ( : subshell because we muck with IFS
170 IFS=" $LF"
171 (
9debc324
PB
172 if test "$remote" = . ; then
173 git-show-ref $rref || echo failed "$remote"
174 elif test -f "$remote" ; then
c1f5086e
JH
175 test -n "$shallow_depth" &&
176 die "shallow clone with bundle is not supported"
177 git-bundle unbundle "$remote" $rref ||
178 echo failed "$remote"
179 else
e3c6f240
JH
180 if test -d "$remote" &&
181
182 # The remote might be our alternate. With
183 # this optimization we will bypass fetch-pack
184 # altogether, which means we cannot be doing
185 # the shallow stuff at all.
186 test ! -f "$GIT_DIR/shallow" &&
187 test -z "$shallow_depth" &&
188
189 # See if all of what we are going to fetch are
190 # connected to our repository's tips, in which
191 # case we do not have to do any fetch.
afb5f39e
OH
192 theirs=$(echo "$ls_remote_result" | \
193 git-fetch--tool -s pick-rref "$rref" "-") &&
e3c6f240
JH
194
195 # This will barf when $theirs reach an object that
196 # we do not have in our repository. Otherwise,
197 # we already have everything the fetch would bring in.
198 git-rev-list --objects $theirs --not --all \
199 >/dev/null 2>/dev/null
200 then
afb5f39e
OH
201 echo "$ls_remote_result" | \
202 git-fetch--tool pick-rref "$rref" "-"
e3c6f240 203 else
684f6742
AR
204 flags=
205 case $verbose in
206 YesYes*)
207 flags="-v"
208 ;;
209 esac
e3c6f240 210 git-fetch-pack --thin $exec $keep $shallow_depth \
684f6742 211 $quiet $no_progress $flags "$remote" $rref ||
e3c6f240
JH
212 echo failed "$remote"
213 fi
c1f5086e 214 fi
b74e8cbd
JH
215 ) |
216 (
fbe2687e
JH
217 flags=
218 test -n "$verbose" && flags="$flags -v"
219 test -n "$force" && flags="$flags -f"
220 GIT_REFLOG_ACTION="$GIT_REFLOG_ACTION" \
fee7c2c7
JH
221 git-fetch--tool $flags native-store \
222 "$remote" "$remote_nick" "$refs"
b74e8cbd
JH
223 )
224 ) || exit
225
226}
227
9debc324 228fetch_per_ref () {
03febf99
JH
229 reflist="$1"
230 refs=
4839bd8a 231 rref=
f170e4b3 232
03febf99
JH
233 for ref in $reflist
234 do
235 refs="$refs$LF$ref"
f170e4b3 236
03febf99
JH
237 # These are relative path from $GIT_DIR, typically starting at refs/
238 # but may be HEAD
f327dbce 239 if expr "z$ref" : 'z\.' >/dev/null
03febf99
JH
240 then
241 not_for_merge=t
f327dbce 242 ref=$(expr "z$ref" : 'z\.\(.*\)')
03febf99
JH
243 else
244 not_for_merge=
245 fi
dfdcb558 246 if expr "z$ref" : 'z+' >/dev/null
03febf99
JH
247 then
248 single_force=t
dfdcb558 249 ref=$(expr "z$ref" : 'z+\(.*\)')
03febf99
JH
250 else
251 single_force=
252 fi
f327dbce
MW
253 remote_name=$(expr "z$ref" : 'z\([^:]*\):')
254 local_name=$(expr "z$ref" : 'z[^:]*:\(.*\)')
853a3697 255
03febf99 256 rref="$rref$LF$remote_name"
4447badc 257
03febf99
JH
258 # There are transports that can fetch only one head at a time...
259 case "$remote" in
38529e28 260 http://* | https://* | ftp://*)
f53514bc
JS
261 test -n "$shallow_depth" &&
262 die "shallow clone with http not supported"
ddaf7314 263 proto=`expr "$remote" : '\([^:]*\):'`
03febf99
JH
264 if [ -n "$GIT_SSL_NO_VERIFY" ]; then
265 curl_extra_args="-k"
266 fi
3ea099d4 267 if [ -n "$GIT_CURL_FTP_NO_EPSV" -o \
e0d10e1c 268 "`git-config --bool http.noEPSV`" = true ]; then
3ea099d4
SK
269 noepsv_opt="--disable-epsv"
270 fi
2986c022
JH
271
272 # Find $remote_name from ls-remote output.
afb5f39e
OH
273 head=$(echo "$ls_remote_result" | \
274 git-fetch--tool -s pick-rref "$remote_name" "-")
f327dbce 275 expr "z$head" : "z$_x40\$" >/dev/null ||
2986c022 276 die "No such ref $remote_name at $remote"
ddaf7314 277 echo >&2 "Fetching $remote_name from $remote using $proto"
a858c006 278 case "$quiet" in '') v=-v ;; *) v= ;; esac
27be481f 279 git-http-fetch $v -a "$head" "$remote" || exit
03febf99
JH
280 ;;
281 rsync://*)
f53514bc
JS
282 test -n "$shallow_depth" &&
283 die "shallow clone with rsync not supported"
03febf99
JH
284 TMP_HEAD="$GIT_DIR/TMP_HEAD"
285 rsync -L -q "$remote/$remote_name" "$TMP_HEAD" || exit 1
286 head=$(git-rev-parse --verify TMP_HEAD)
287 rm -f "$TMP_HEAD"
a858c006 288 case "$quiet" in '') v=-v ;; *) v= ;; esac
03febf99 289 test "$rsync_slurped_objects" || {
a858c006 290 rsync -a $v --ignore-existing --exclude info \
03febf99 291 "$remote/objects/" "$GIT_OBJECT_DIRECTORY/" || exit
853a3697 292
03febf99
JH
293 # Look at objects/info/alternates for rsync -- http will
294 # support it natively and git native ones will do it on
295 # the remote end. Not having that file is not a crime.
296 rsync -q "$remote/objects/info/alternates" \
297 "$GIT_DIR/TMP_ALT" 2>/dev/null ||
298 rm -f "$GIT_DIR/TMP_ALT"
299 if test -f "$GIT_DIR/TMP_ALT"
300 then
301 resolve_alternates "$remote" <"$GIT_DIR/TMP_ALT" |
302 while read alt
303 do
304 case "$alt" in 'bad alternate: '*) die "$alt";; esac
305 echo >&2 "Getting alternate: $alt"
306 rsync -av --ignore-existing --exclude info \
307 "$alt" "$GIT_OBJECT_DIRECTORY/" || exit
308 done
309 rm -f "$GIT_DIR/TMP_ALT"
310 fi
311 rsync_slurped_objects=t
312 }
313 ;;
03febf99 314 esac
f170e4b3 315
03febf99 316 append_fetch_head "$head" "$remote" \
f64d7fd2 317 "$remote_name" "$remote_nick" "$local_name" "$not_for_merge" || exit
853a3697 318
03febf99
JH
319 done
320
b74e8cbd 321}
03febf99 322
b74e8cbd
JH
323fetch_main () {
324 case "$remote" in
325 http://* | https://* | ftp://* | rsync://* )
9debc324 326 fetch_per_ref "$@"
b74e8cbd
JH
327 ;;
328 *)
9debc324 329 fetch_all_at_once "$@"
b74e8cbd
JH
330 ;;
331 esac
03febf99
JH
332}
333
f64d7fd2 334fetch_main "$reflist" || exit
03febf99
JH
335
336# automated tag following
337case "$no_tags$tags" in
338'')
6dc78e69
JH
339 case "$reflist" in
340 *:refs/*)
341 # effective only when we are following remote branch
342 # using local tracking branch.
ed9f7c95 343 taglist=$(IFS=' ' &&
28b8e61f 344 echo "$ls_remote_result" |
ed9f7c95 345 git-show-ref --exclude-existing=refs/tags/ |
6dc78e69
JH
346 while read sha1 name
347 do
6dc78e69
JH
348 git-cat-file -t "$sha1" >/dev/null 2>&1 || continue
349 echo >&2 "Auto-following $name"
350 echo ".${name}:${name}"
351 done)
352 esac
03febf99
JH
353 case "$taglist" in
354 '') ;;
355 ?*)
d1586315
AJ
356 # do not deepen a shallow tree when following tags
357 shallow_depth=
f64d7fd2 358 fetch_main "$taglist" || exit ;;
03febf99 359 esac
853a3697 360esac
b10ac50f
JH
361
362# If the original head was empty (i.e. no "master" yet), or
363# if we were told not to worry, we do not have to check.
9861718b
JH
364case "$orig_head" in
365'')
b10ac50f 366 ;;
9861718b 367?*)
bf7960eb 368 curr_head=$(git-rev-parse --verify HEAD 2>/dev/null)
b10ac50f
JH
369 if test "$curr_head" != "$orig_head"
370 then
55b7835e 371 git-update-ref \
f9474132 372 -m "$GIT_REFLOG_ACTION: Undoing incorrectly fetched HEAD." \
55b7835e 373 HEAD "$orig_head"
b10ac50f
JH
374 die "Cannot fetch into the current branch."
375 fi
376 ;;
377esac